/* klasė, vykdanti grid intervalinę paiešką
 */

#ifndef GRID_H
#define GRID_H

#include <qpoint.h>
#include <qrect.h>
#include <qptrlist.h>
#include <qvaluevector.h>
#include <qobject.h>

class Grid: public QObject
{
		Q_OBJECT
	private:
		QRect area;
		int grid_width;
		int grid_height;
		int cmp_count;
		int found_count;
		
		QPtrList<QPoint> *points;
		QValueVector< QValueVector< QPtrList<QPoint> > > lists;
		
		void clearLists();
		void updateGrid();
		void updatePoint(QPoint *p);
	public:
		Grid();
		Grid(const QRect &_area, int gridw, int gridh);
		~Grid();
		
		void clear();
		void updatePoints();
		void setPoints(QPtrList<QPoint> *list);
		void setGridSize(int width, int height);
		void setArea(const QRect &area);
		
		bool addPoint(QPoint *p);
		void removePoint(QPoint *p);
		
		int getGridWidth();
		int getGridHeight();
		QRect &getArea();
		
		QPtrList<QPoint> *search(const QRect &rect);
		
		int getListCount();
		int getPointCount();
		int getCmpCount();
		int getFoundCount();
	
	signals:
		void listsChanged();
		void pointsChanged();
		void cmpChanged();
		void foundChanged();
};

#endif // GRID_H

