/* grid metodą vizualizuojanti klasė GridView
 */

#ifndef GRIDVIEW_H
#define GRIDVIEW_H

#include <qframe.h>
#include <qptrlist.h>
#include <qpoint.h>
#include <qrect.h>
#include <qpixmap.h>

class Grid;

class GridView: public QFrame
{
	Q_OBJECT
	public:
		typedef enum _GridEditMode {gemReadOnly, gemNewPoints, gemMovePoints,
			gemSelectInterval} GridEditMode;
	private:
		Grid *grid;
		QPtrList<QPoint> *points;
		QPtrList<QPoint> *found;
		
		GridEditMode mode;
		
		QRect selection;
		bool selected;
		QPoint start;
		QPoint end;
		
		QPixmap *point_img;
		QPixmap *fpoint_img;
		
	protected:
		void clearFound();
		void drawPoint(QPainter *painter, const QPoint &p, bool f);
		void paintEvent(QPaintEvent *e);
		void resizeEvent(QResizeEvent *e);
		void mousePressEvent(QMouseEvent *e);
		void mouseReleaseEvent(QMouseEvent *e);
		void mouseMoveEvent(QMouseEvent *e);
	public:
		GridView(QWidget *parent=0, const char *name=0);
		~GridView();
		
		void addPoint(int x, int y);
		
		Grid *getGrid();
		
		GridEditMode getMode();
		void setMode(GridEditMode m);
		void setGridSize(int w, int h);
		
	public slots:
		void clear();
		void search();
};

#endif //GRIDVIEW_H

